



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>11.2 Flask 配置文件，路由系统</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">11.2 Flask 配置文件，路由系统</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:45:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>配置文件系统</h1>
<h2>构建 Flask 应用时指定</h2>
<div>
<pre class="prettyprint linenums">app = Flask(<br />
   __name__,<br />
   template_folder = '',　　# 指定存储模板文件夹名称<br />
   static_url_path = '',　　# 指定静态文件访问路径<br />
   static_folder = '',　　　# 指定存储静态文件的文件夹名称<br />
)</pre>
</div>
<p>一般不推荐修改此配置. 默认的配置即可</p>
<h2>启动程序时指定运行配置</h2>
<div>
<pre class="prettyprint linenums">app.run(<br />
　　debug = True,　　　　# 调试模式<br />
　　port = 8888 　　　　 # 端口<br />
　　host = '0.0.0.0'　　# 指定能够访问到本项目的ip地址,不设置此的话只能自己和自己玩<br />
)</pre>
</div>
<h2>自定义配置文件</h2>
<p>创建一个 setting.py 用于存放配置文件的相关属性</p>
<p>配置文件中可以进行分级继承来区分不同视图的配置文件设置</p>
<p>默认配置文件放在项目根路径下</p>
<div>
<pre class="prettyprint linenums"># settings.py

    class Base(object):    # 所有的都要有用到的配置更改<br />
        TEST = True

    class Dev(Base):<br />
        DEV = True

    class Pro(Base):<br />
        PRO = True </pre>
</div>
<h3>配置文件的设置方式</h3>
<p>常用的是以下三种</p>
<div>
<pre class="prettyprint linenums"># 方式1 直接更改<br />
app.config["要更改的字段"] = True<br />
 <br /># 方式2 指定对象方式<br />
# app.config.from_object("settings.Dev")    # 通过另外指定配置文件来保存更改<br />
app.config.from_object("settings.Pro")    # 可以指定多套配置文件随意切换 

# 方式3 指定文件方式 <br />app.config.from_pyfile("settings.py")  # 通过配置文件名来<br /># PS: 从sys.path中已经存在路径开始写</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
</div>
<h2>默认的配置文件</h2>
<p>flask中的配置文件是一个flask.config.Config对象（继承字典），默认的配置如下</p>
<div>
<pre class="prettyprint linenums">　　 'DEBUG':                                get_debug_flag(default=False),  是否开启Debug模式<br />
    'TESTING':                              False,                          是否开启测试模式<br />
    'PROPAGATE_EXCEPTIONS':                 None,<br />
    'PRESERVE_CONTEXT_ON_EXCEPTION':        None,<br />
    'SECRET_KEY':                           None,<br />
    'PERMANENT_SESSION_LIFETIME':           timedelta(days=31),<br />
    'USE_X_SENDFILE':                       False,<br />
    'LOGGER_NAME':                          None,<br />
    'LOGGER_HANDLER_POLICY':               'always',<br />
    'SERVER_NAME':                          None,<br />
    'APPLICATION_ROOT':                     None,<br />
    'SESSION_COOKIE_NAME':                  'session',<br />
    'SESSION_COOKIE_DOMAIN':                None,<br />
    'SESSION_COOKIE_PATH':                  None,<br />
    'SESSION_COOKIE_HTTPONLY':              True,<br />
    'SESSION_COOKIE_SECURE':                False,<br />
    'SESSION_REFRESH_EACH_REQUEST':         True,<br />
    'MAX_CONTENT_LENGTH':                   None,<br />
    'SEND_FILE_MAX_AGE_DEFAULT':            timedelta(hours=12),<br />
    'TRAP_BAD_REQUEST_ERRORS':              False,<br />
    'TRAP_HTTP_EXCEPTIONS':                 False,<br />
    'EXPLAIN_TEMPLATE_LOADING':             False,<br />
    'PREFERRED_URL_SCHEME':                 'http',<br />
    'JSON_AS_ASCII':                        True,<br />
    'JSON_SORT_KEYS':                       True,<br />
    'JSONIFY_PRETTYPRINT_REGULAR':          True,<br />
    'JSONIFY_MIMETYPE':                     'application/json',<br />
    'TEMPLATES_AUTO_RELOAD':                None,</pre>
</div>
<h2><strong>视图函数取配置</strong></h2>
<p><strong>要想在视图函数中获取配置文件的值</strong>，都是通过app.config来拿。</p>
<p>但是如果视图函数和Flask创建的对象app不在一个模块。就得导入来拿。</p>
<p>可以不用导入，直接导入一个current_app，这个就是当前的app对象，用current_app.config就能查看到了当前app的所有的配置文件</p>
<div>
<pre class="prettyprint linenums">from flask import Flask,current_app</pre>
</div>
<div>
<pre class="prettyprint linenums">@app.route('/index',methods=["GET","POST"])<br />
def index():<br />
    print(current_app.config)   #当前的app的所有配置<br />
    session["xx"] = "fdvbn"<br />
    return "index"</pre>
</div>
<h1>路由系统</h1>
<h1>FBV 的路由添加方式</h1>
<h2>语法</h2>
<div>
<pre class="prettyprint linenums">@app.route(参数)</pre>
</div>
<h2>可选参数</h2>
<h3><strong>rule</strong></h3>
<p>设置动态路由，路径中可以带参数 ，必须要指定类型</p>
<div>
<pre class="prettyprint linenums">/index/&lt;int:nid&gt;</pre>
</div>
<p><strong> 仅允许的类型</strong></p>
<ul><li>string 字符串</li>
<li>float 浮点型</li>
<li>path 路径</li>
<li>int 整型</li>
<li>any 任何</li>
<li>uuid uuid类型</li></ul>
<p>默认的不支持正则路由匹配的</p>
<p>默认不指定的时候按str 处理</p>
<p><strong>实例</strong></p>
<div>
<pre class="prettyprint linenums">from flask import Flask

# 将当前的运行的主程序构建成 Flask 应用, 以便去接受用户的请求和响应<br />
app = Flask(__name__)

# 路由定义, 目的是为了匹配用户的访问路径<br />
# "/" 表示整个网站的根 " index " 表示自定义的访问路径<br />
# index() 表示匹配上访问路径后的处理程序( views ), 此函数必须要有返回值 ( 字符串 / 模板文件 )<br />
@app.route('/index')<br />
def index():<br />
    return "&lt;h1&gt; 这是我的网站的首页 &lt;/h1&gt;"

# 无参数<br />
@app.route('/')<br />
def first():<br />
    return "This is my first flask demo"

# 单参数<br />
@app.route('/name/&lt;name&gt;')<br />
def name(name):<br />
    return "This is {0} first flask".format(name)

# 带类型的参数<br />
@app.route('/num/&lt;int:num&gt;')<br />
def num(num):<br />
    return "get a unm: {0} ".format(num)

"""<br />
可选的参数类型<br />
    str:    字符串,不能加　"/"<br />
    int:    整数<br />
    float:  浮点型<br />
    path:   路径,本质还是字符串, 但是可以加 "/"<br />
        不推荐使用 path 容易误解<br />
 """

# 多参数<br />
# str 类型不需要加　&lt;str:...&gt;<br />
@app.route('/more/&lt;name&gt;/&lt;int:age&gt;')<br />
def more(name, age):<br />
    return " name : {name} ; age: {age}".format(name=name, age=age)<br />
    # return "name: %s ; age : %s" % (name, age)

if __name__ == '__main__':<br />
    # debug = True  # 调试模式, 部署运行是设置为 False<br />
    app.run(debug=True)  # 启动程序</pre>
</div>
<p><strong>多 URL 的路由匹配方式</strong></p>
<p>允许多个路由匹配到同一个 视图上</p>
<div>
<pre class="prettyprint linenums">@app.route('/manyA/')<br />
@app.route('/manyB/')<br />
@app.route('/manyC/')<br />
def many():<br />
    return "我可以匹配多个URL , 厉害吧"</pre>
</div>
<h4>URL 中适配正则的验证方式</h4>
<div>
<pre class="prettyprint linenums">from flask import Flask,url_for

    app = Flask(__name__)

    # 定义转换的类<br />
    from werkzeug.routing import BaseConverter<br />
    class RegexConverter(BaseConverter):<br />
        """<br />
        自定义URL匹配正则表达式<br />
        """

        def __init__(self, map, regex):<br />
            super(RegexConverter, self).__init__(map)<br />
            self.regex = regex

        def to_python(self, value):<br />
            """<br />
            路由匹配时，匹配成功后传递给视图函数中参数的值<br />
            :param value:<br />
            :return:<br />
            """<br />
            return int(value)

        def to_url(self, value):<br />
            """<br />
            使用url_for反向生成URL时，传递的参数经过该方法处理，返回的值用于生成URL中的参数<br />
            :param value:<br />
            :return:<br />
            """<br />
            val = super(RegexConverter, self).to_url(value)<br />
            return val

    # 添加到converts中<br />
    app.url_map.converters['regex'] = RegexConverter

    # 进行使用<br />
    @app.route('/index/&lt;regex("\d+"):nid&gt;',endpoint='xx')<br />
    def index(nid):<br />
        url_for('xx',nid=123)  #反向生成，就会去执行to_url方法<br />
        return "Index"

    if __name__ == '__main__':<br />
        app.run()</pre>
</div>
<h3>default 添加默认值示例</h3>
<div>
<pre class="prettyprint linenums">from flask import Flask

app = Flask(__name__)

# 2. 函数index需要参数,但是url里无参数,即可以用defaults={"k":"v"}为函数提供参数<br />
@app.route("/",methods=['GET','POST'],defaults={"nid":888})<br />
# 1. 函数index需要参数,但是url里无参数<br />
def index(nid):<br />
    print(nid)      # 会在工作它打印nid   888<br />
    return "Hello World!"

if __name__ =="__main__":<br />
    app.run()</pre>
</div>
<h3>strict_slashes &ldquo;/&rdquo; 示例</h3>
<div>
<pre class="prettyprint linenums">@app.route('/index',strict_slashes=False)，<br />
    访问 http://www.xx.com/index/ 或 http://www.xx.com/index均可<br />
@app.route('/index',strict_slashes=True)<br />
    仅访问 http://www.xx.com/index </pre>
</div>
<h3>redirect_to 重定向示例</h3>
<p>原url有参数时，跳转是也得传参，注意：不用加类型</p>
<div>
<pre class="prettyprint linenums">#/old<br />
@app.route('/old/&lt;int:nid&gt;',redirect_to="/new/&lt;nid&gt;")<br />
def old(nid):<br />
    return "old"<br />
# /new<br />
@app.route('/new/&lt;int:nid&gt;')<br />
def new(nid):<br />
    return "new"</pre>
</div>
<h3>subdomain 子域名示例</h3>
<div>
<pre class="prettyprint linenums">from flask import Flask, views, url_for

app = Flask(import_name=__name__)<br />
app.config['SERVER_NAME'] = 'haiyan.com:5000'

@app.route("/", subdomain="admin")<br />
def static_index():<br />
    return "admin.xxx.com"<br />
<br />#动态生成<br />
@app.route("/dynamic", subdomain="&lt;username&gt;")<br />
def username_index(username):<br />
    return username + ".your-domain.tld"

if __name__ == '__main__':<br />
    app.run()</pre>
</div>
<h2><strong>路由系统的本质</strong></h2>
<p>通过源码分析。<br />			@app.route()的本质就是执行了 add_url_rule(rule,endpoint,f,**options) 方法 <br />			因此我们也可以在这里操作也可以添加路由映射  主流并不是用这种。就装饰器就可以了</p>
<div>
<pre class="prettyprint linenums">from flask import Flask

app = Flask(__name__)<br />
app.config.from_object("settings.DevelopmentConfig")

'''<br />
看到路由系统，分析路由系统干了什么？<br />
第一步：先执行：decorator = app.route("/", methods= ['GET','POST'], endpoint='n1')<br />
    根据源码，第一步执行了下面的函数,返回decorator，这就是一个闭包，闭包给谁用，谁以后执行这个函数就给谁用<br />
    def route(self, rule, **options):<br />
        # 具体值与参数的对应关系：<br />
        # app对象<br />
        # rule = "/"<br />
        # options = {methods= ['GET','POST'], endpoint='n1'}<br />
        def decorator(f):<br />
            endpoint = options.pop('endpoint', None)<br />
            self.add_url_rule(rule, endpoint, f, **options)<br />
            return f<br />
        return decorator<br />
第二步: 第一步返回了decorator，所以相当于是： @decorator，等价于decorator(index),触发上面route函数下面的decorator函数的运行<br />
        def decorator(f):<br />
            endpoint = options.pop('endpoint', None)<br />
            self.add_url_rule(rule, endpoint, f, **options)  # self就是app对象。加到了路由的对应表里去了，那里有url对应的函数<br />
            return f

最后总结一下，添加路由关系的本质，其实就是最终执行 self.add_url_rule(rule, endpoint, f, **options),生成路由的对应关系 

'''<br />
#  对于endpoint还要注意：<br />
#  如果endpoint没有写，根据源码可知，默认的就是函数名，即该路由对应函数，如index（endpoint = index)<br />
@app.route("/", methods= ['GET','POST'], endpoint='n1')<br />
def index():<br />
    return "Hello World!"

def login():<br />
    return "登录"

# 所以根据源码的原理，也可以按照下面的方式添加路由对应关系，就与Django类似了。但是在Flask里，还是要按照装饰器的方式去添加路由对应关系<br />
app.add_url_rule('/login', 'n2', login, methods= ['GET','POST'])

if __name__ == "__main__":<br />
    app.run()</pre>
</div>
<h2>CBV 的路由添加方式</h2>
<div>
<pre class="prettyprint linenums">def auth(func):<br />
    def inner(*args, **kwargs):<br />
        result = func(*args, **kwargs)<br />
        return result<br />
    return inner

class IndexView(views.MethodView):<br />
    # methods = ['POST']  #只允许POST请求访问<br />
    decorators = [auth,]  #如果想给所有的get,post请求加装饰器，就可以这样来写，也可以单个指定

    def get(self):   #如果是get请求需要执行的代码<br />
        v = url_for('index')<br />
        print(v)<br />
        return "GET"

    def post(self):  #如果是post请求执行的代码<br />
        return "POST"

app.add_url_rule('/index', view_func=IndexView.as_view(name='index'))  #name指定的是别名，会当做endpoint使用</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlle70q.html">php中htmlspecialchars&lpar;&rpar;函数和addslashes&lpar;&rpar;函数的使用和区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e0zdkq.html">ZeroMQ接口函数之 ：zmq&lowbar;bind - 绑定一个socket</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvjyozq.html">linux  crontab 命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7n209.html">Configurataion Printer（基于全新2&period;2&period;0API）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v3x3m8.html">IE下判断IE版本的语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1d1em9.html">uva 10026 Shoemaker&amp;&num;39&semi;s Problem &lowbar;贪心</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1y73dq.html">API HOOK库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zd4mj9.html">CSS学习（页外引用还不懂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojy6kxq.html">Misra-Gries 算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kwk169.html">jenkins、ant、selenium、testng搭建自动化测试框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z2owj9.html">&lbrack;BZOJ2733&rsqb; &lbrack;HNOI2012&rsqb; 永无乡 &lpar;splay启发式合并&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1vxk9.html">制作自己的docker镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyyp2xq.html">Windows 10 安装 Mongod</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j3yznq.html">1&period; redis安装（windows）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1d0y09.html">tensorflow实战系列（四）基于TensorFlow构建AlexNet代码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw5lg48.html">PHP中MySQL、MySQLi和PDO的用法和区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkgv638.html">Python正则表达式操作指南&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9022dn3q.html">OAuth 授权过程工作原理讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2ldmd8.html">【GIS】Cesium回到初始位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emw7wx9.html">数组内数据不使用for循环实现多个移动</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pd04kz9.html">python 实例四</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rge21e8.html">【公众号系列】SAP HANA 平台的优势</a>
			</li>
						<li><a href="https://www.batexi.com/a/9504en08.html">sqlserver数据库触发器调用外部exe</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1m7ljq.html">Expression</a>
			</li>
						<li><a href="https://www.batexi.com/a/9504oje8.html">python3 dict（字典）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zr0r09.html">【PAT】A1002 A&plus;B for Polynomials</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv164poq.html">我的第一个python web开发框架（29）&mdash;&mdash;定制ORM（五）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96px1mn8.html">Cloudera Manager和CDH5&period;8离线安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpywy79.html">web框架开发-Django模型层&lpar;1&rpar;之ORM简介和单表操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpy3v59.html">CSAPP：第八章 异常控制流2</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
